# PlayerBots
Adds ai controlled teammates to your game.

## Features
- Playerbots can be spawned as regular summons or as players. They spawn as summons by default, but can but spawned as players by changing `SpawnAsPlayers` in the config.
- Each bot has its own owner that it follows.
- Bots spawned as players can pick up items, show up on the scoreboard, influence map player scaling, and all the other stuff that happens when there are multiple people.
- Only the host needs to have this mod installed, however, if the bots are spawned as summons, nameplates will not shown on clients.
- Bots automatically purchase items when they have enough money AND/OR they can be set to open chests (Toggleable in the config)

## Installation
Put `Playerbots.dll` into your `/BepInEx/plugins` folder.

## How to Spawn Bots
You can spawn bots by opening your console (ctrl + alt + tilda) and running the command `addbot [survivor name OR survivor index] [amount]` or `addrandombot [amount]`. All arguements are optional and have a default value if they are not given. Example: `addbot engineer 5` will spawn 5 engineers that follow you.

If you have friends in your lobby that you want to spawn bots for, add their slot number in the lobby after the rest of the arguements. Example: `addbot engineer 5 3` will spawn 5 engineers for the 3rd player in the lobby.

Alternatively, you can set the amount of bots spawned at the beginning of a run in the config. These bots will default to having the host as their master.

## Other Console Commands

`pb_startingbots [survivor name OR survivor index] [amount]` - Changes the amount of bots spawned at the beginning of a run.

`pb_startingbots_random [amount]` - Changes the amount of random bots spawned at the beginning of a run.

`pb_startingbots_reset` - Resets the amount of all bots that spawn at the beginning of a run to 0.

`pb_listsurvivors` - Lists all the loaded survivors and their index numbers, useful for adding bots

`removebots` - Removes all bots from the run

`killbots` - Kills all the bots currently in the run. They will respawn in the next stage.

`tpbots` - Teleports all the bots to your position

## Supported Custom Characters

[Akali](https://thunderstore.io/package/Matarra/PlayableAkali/)
[BanditReloaded](https://thunderstore.io/package/Moffein/BanditReloaded/)
[Chef](https://thunderstore.io/package/LuaFubuki/BackupSquad/)
[Enforcer](https://thunderstore.io/package/LuaFubuki/BackupSquad/)
[Gauss](https://thunderstore.io/package/LuaFubuki/GaussMod/)
[Gunslinger](https://thunderstore.io/package/Dragonyck/Gunslinger/)
[Gurren Lagann](https://thunderstore.io/package/Mico27/TTGL_Mod/)
[HAND OVERCLOCKED](https://thunderstore.io/package/Moffein/HAND_OVERCLOCKED_BETA/)
[Henry](https://thunderstore.io/package/rob/HenryMod/)
[Hermit Crab](https://thunderstore.io/package/LuaFubuki/Hermit_Crab/)
[Imp](https://thunderstore.io/package/Tymmey/Lemurian/)
[Lagann](https://thunderstore.io/package/Mico27/TTGL_Mod/)
[Lemurian](https://thunderstore.io/package/Tymmey/Lemurian/)
[Lil' Heretic](https://thunderstore.io/package/LuaFubuki/Lil_Heretic/)
[Lunar Golem](https://thunderstore.io/package/LuaFubuki/Lunar_Golem/)
[Miner](https://thunderstore.io/package/rob/MinerUnearthed/)
[Paladin](https://thunderstore.io/package/rob/PaladinMod/)
[Riven](https://thunderstore.io/package/ArcsinJesse/Riven/)
[Rengar](https://thunderstore.io/package/Dragonyck/Rengar/)
[Samus](https://thunderstore.io/package/dgosling/dgoslings_Samus_Mod/)
[Sniper](https://thunderstore.io/package/Rein/Sniper/)
[Temmo](https://thunderstore.io/package/Dragonyck/Teemo/)
[Tracer](https://thunderstore.io/package/Dragonyck/Tracer/)
[Void Reaver](https://thunderstore.io/package/LuaFubuki/Void_Reaver/)

## Known Issues

Due to the Skills 2.0 update, bots spawned with `PlayerMode` set to true no longer have their healthbars show up for people without the mod.

## Changelog
	- 1.6.1 (ror2 1.2.3.1)
		- Updated to work with the latest patch
	- 1.6.0 (ror2 1.2.2.0)
		- Updated for Survivors of the Void
		- Fixed console errors and lag when BotsUseInteractables is set to true
		- Fixed bots not activating teleporters when ContinueAfterDeath is set to true
	- 1.5.3 (ror2 1.1.1.2)
		- Fix logbook issue when custom survivor mods are loaded
	- 1.5.2 (ror2 1.1.1.2)
		- Updated to work with newest ror2 update
		- Fixed null pointer spam on stage loading if certain config options were enabled
	- 1.5.1 (ror2 1.1.0.1)
		- Updated dependencies
		- Added config options for bots to use interactables (opening chests, using teleporters) and to continue the game when all real players have died
		- Improved bandit ai
		- Added more support for custom survivors
	- 1.5.0 (ror2 1.1.0.1)
		- Updated to anniversary update
		- Updated list of supported custom survivors
		- Added support for bandit and heretic survivors (heretic is NOT in the random bot pool)
	- 1.4.1 (ror2 1.0.1.1)
		- Bots now buy equipments from available ones in the run
		- Bots should no longer respond to friendly fire
		- Bots now remove their equipment if they cant use it
		- Bots spawn in the mithrix arena instead of the the default spawn in the moon stage (there was no pathfinding there)
		- Added commands to teleport and freeze bots
		- Added support for a few custom characters
	- 1.4.0 (ror2 1.0.0.6)
		- Updated for 1.0 update
		- Added basic captain compatibility
		- Bot purchases now show up as chat messages (configurable)
	- 1.3.0 (ror2 build 4478858)
		- Updated to work with the Hidden Realms update
		- Added acrid compatibility
		- Added ability for bots to buy and use some equipment
	- 1.2.1 (ror2 build 4233443)
		- Updated to work with the latest versions of r2api
		- Some tweaks to MULT's ai
		- Added a fix for the healthbars of bots spawned as players
	- 1.2.0 (ror2 build 4164475)
		- Updated to work with the Skills 2.0 update
		- Added basic loader compatibility
		- Corrected skill timing issues with bots during combat, survivors like mult should work better
		- Bots now spawn with random skins
	- 1.1.0 (ror2 build 3961583)
		- Added bandit compatibility
		- Added extra config options for auto purchasing
		- Added death messages for bots
		- Fixed bots not counting towards the teleporter timer when SpawnAsPlayers == true
	- 1.0.1
		- Fixed starting bots attacking you
		- Added pb_listbots command to display bots' owners
	- 1.0.0 
		- Initial Release